
/*
 * Autonomous 2nd sun
 * ==================
 * 
 * switch, getTarget, save to EEPROM, sunTracker, check if tracker is ready, align Mirror, sleep
 */

#include <EEPROM.h>
#include <LowPower.h>
#include <Servo.h>

Servo trackHorizontal; // trackHorizontal servo
int servoh = 90;
Servo trackVertical; // trackVertical servo 
int servov = 90;
Servo MirrorX;
Servo MirrorY;
int actualX =90, actualY=90;
int newX, newY;
int i, j;

int dtime = 4; // delay time
int tol = 2;    // tolerance
int readycounter = 0;

const int joyH = A1;        // L/R  joystick
const int joyV = A2;        // U/D  joystick
int Xpos = 90, Ypos = 90;

int servoX, servoY;           // variable to read the values from analog pins

// button/switch
const int button1Pin = 12;
int button1State = 0;
const int button2Pin = 11;
int button2State = 0;

// LDR
  int avt, avd,  avl, avr;
  int dvert=50, dhoriz=50;



void setup() {
  Serial.begin(9600);
  //buttons
  pinMode(button1Pin, INPUT_PULLUP);
  pinMode(button2Pin, INPUT_PULLUP);
  pinMode(A1, INPUT);
  pinMode(A2, INPUT);
  

  // LDR
  pinMode(A3, INPUT);
  pinMode(A4, INPUT);
  pinMode(A5, INPUT);
  pinMode(A6, INPUT);

  pinMode(LED_BUILTIN, OUTPUT);
  //Serial.println("setup done");
  
}

void loop() {

  
  button2State = digitalRead(button2Pin);
  if (button2State == LOW) {    // choose your target
    Serial.println("set target");
      trackHorizontal.attach(2); 
      trackVertical.attach(3); delay(10);
    getTarget();
  }
  
  if (button2State == HIGH) {   // main loop to find sun and adjust mirror
    Serial.println("");
    delay(1000);

    //Serial.println("sunTracker active");
        trackHorizontal.attach(2); 
        trackVertical.attach(3); delay(10);
    sunTracker();



   if ((abs(dvert) < tol) && (abs(dhoriz) < tol))  readycounter += 1;
   if ((abs(dvert) >= tol) && (abs(dhoriz) >= tol))  readycounter = 0;
   if (readycounter > 5) {
     Serial.println("tracking done");
     readycounter = 0;
     
      trackHorizontal.detach(); 
      trackVertical.detach(); delay(10);
      MirrorX.attach(4);
      MirrorY.attach(5);
  
     delay(500);
     Serial.println("Mirror active");
     alignMirror();
/*
     Serial.println("");Serial.println("- - - - - - - - -");
      Serial.print("Target:  ");Serial.print(Xpos); Serial.print("  "); Serial.println(Ypos);
      Serial.print("Sun   :  ");Serial.print(servoh); Serial.print("  "); Serial.println(servov);
      Serial.print("Mirror:  ");Serial.print(newX); Serial.print("  "); Serial.println(newY);
     Serial.println("- - - - - - - - -");
*/
      MirrorX.detach();
      MirrorY.detach();
     sleep();
    }
   }
  delay(100); //  =  =  =  =  =  =  =  =  =  =  =  =  =  =  = end of loop
}


void getTarget() {
     
    servoX = analogRead(joyH);   // Read the horizontal joystick value
    if (servoX > 530) Xpos = Xpos +1;
      if (Xpos > 170) (Xpos = 170);
    if (servoX < 495) Xpos = Xpos -1;
      if (Xpos < 10) (Xpos = 10);
    trackHorizontal.write(Xpos);
    delay(15);
    
    servoY = analogRead(joyV);   // Read the horizontal joystick value        
    if (servoY > 530) Ypos = Ypos +1;
      if (Ypos > 150) (Ypos = 150);
    if (servoY < 495) Ypos = Ypos -1;
      if (Ypos < 30) (Ypos = 30);
    trackVertical.write(Ypos);
    delay(15);

  button1State = digitalRead(button1Pin);
  if (button1State == LOW) {
    // save XY to EEPROM here
    EEPROM.update(0, Xpos);
    EEPROM.update(1, Ypos);
    Serial.print("X:  ");Serial.print(Xpos);Serial.print("     Y:  ");Serial.println(Ypos);
    Serial.println("saved to EEPROM");
    blinkLED();   //confirm the storage
  }
  delay(100);
}


void sunTracker() {

 do {
  
  int rd = analogRead(A3); // down rigt 
  int rt = analogRead(A4); // top right
  int lt = analogRead(A5); // top left
  int ld = analogRead(A6); // down left

  avt = (lt + rt) / 2; // average value top
  avd = (ld + rd) / 2; // average value down
  avl = (lt + ld) / 2; // average value left
  avr = (rt + rd) / 2; // average value right
    
  dvert = avt - avd; // check the diffirence of up and down
  dhoriz = avl - avr;// check the diffirence og left and rigt

  avt = avt - 0;  // calibrate the LDR values
  avd = avd - 4;
  avl = avl - 0;
  avr = avr - 2;

  
  if (-1*tol > dhoriz || dhoriz > tol) { // check if the difference is in the tolerance else change trackHorizontal angle
    if (avl > avr)  {
      servoh = --servoh;
      if (servoh < 10) {
        servoh = 10;
      }
    }
    else if (avl < avr)   {
      servoh = ++servoh;
      if (servoh > 170) {
        servoh = 170;
      }
    }
    else if (avl = avr)
    {
      // do nothing
    }
  trackHorizontal.write(servoh);
  //Serial.print(servoh);Serial.print("  ");
  }


  if (-1*tol > dvert || dvert > tol)  { // check if the difference is in the tolerance else change trackVertical angle
      if (avt > avd) {
        servov = ++servov;
        if (servov > 90) {
          servov = 90;
        }
      }
      else if (avt < avd) {
        servov= --servov;
        if (servov < 30)  {
          servov = 30;
        }
      }
      else if (avt = avd)
      {
        // do nothing
      }
   trackVertical.write(servov);
   //Serial.println(servov);
  }
  delay(dtime);

  Serial.print(abs(dvert)); Serial.print("   "); Serial.print(tol); Serial.print("   ");Serial.println(abs(dhoriz));
  
 } while ((abs(dvert) >= tol) || (abs(dhoriz) >= tol));
}


void alignMirror() {
  
  actualX = EEPROM.read(2);
  actualY = EEPROM.read(3);
  
  MirrorX.write(actualX);
  MirrorY.write(actualY);
  Serial.print("Get target XY values: ");
  Xpos = EEPROM.read(0);
  Ypos = EEPROM.read(1);
  Serial.print(Xpos); Serial.print(" | "); Serial.println(Ypos);

// calculate angle for mirror
  newX = (abs(servoh - Xpos)/2);  Serial.print(" (servoh - Xpos)/2   "); Serial.println(newX);
  newY = (abs(servov - Ypos)/2);  Serial.print(" (servov - Ypos)/2   "); Serial.println(newY);Serial.println("");
  if (Xpos > servoh) newX = servoh + newX;
  if (Xpos <= servoh) newX = Xpos + newX;
  if (Ypos > servov) newY = servov + newY;
  if (Ypos <= servov) newY = Ypos + newY;

/* // fast method
MirrorX.write(newX);
MirrorY.write(newY);
*/


//go to servo position X slowly
  if (actualX < newX){
    Serial.print("   go to new x position +");
    for (i = actualX; i<= newX; i += 1){    // go slowly to the desired position
      MirrorX.write(i);
      delay(15);
    }
    Serial.println("      reached x position +");
  }
  if (actualX > newX){
    Serial.print("   go to new x position -");
    for (i = actualX; i>= newX; i -= 1){
      MirrorX.write(i);
      delay(15);
    }
    Serial.println("      reached x position -");
  }


  //go to servo position Y slowly
  if (actualY < newY){
    Serial.print("   go to new y position +");
    for (j = actualY; j<= newY; j += 1){
      MirrorY.write(j);
      delay(15);
    }
    Serial.println("      reached y position +");
  }
  if (actualY > newY){
    Serial.print("   go to new y position -");
    for (j = actualY; j>= newY; j -= 1){
      MirrorY.write(j);
      delay(15);
    }
    Serial.println("      reached y position -");
  }
  
  EEPROM.update(2, newX); // save mirror position to EEPROM
  EEPROM.update(3, newY);

  delay(50);
Serial.println("");
}



void sleep() {
  Serial.println("Going to sleep for 15x8 seconds (2 min)");
  delay(100);

  for(int s = 1; s<= 15; s++)
    {
    LowPower.idle(SLEEP_8S, ADC_OFF, TIMER2_OFF, TIMER1_OFF, TIMER0_OFF,SPI_OFF, USART0_OFF, TWI_OFF);
    }
  delay(500);
  Serial.println("Arduino: Hey I just Woke up");
  Serial.println("");
}


void blinkLED() {
  digitalWrite(LED_BUILTIN, HIGH);
  delay(500);
  digitalWrite(LED_BUILTIN, LOW);
  delay(500);
  digitalWrite(LED_BUILTIN, HIGH);
  delay(500);
  digitalWrite(LED_BUILTIN, LOW);
  delay(500);  
}
